%def_without static
%def_with milter

%ifdef snap
%define verstring devel-%snap
%else
%define verstring %version
%endif

Name: clamav
Version: 0.75.1
Release: alt1
Summary: An anti-virus utility for Unix
License: GPL
URL: http://www.clamav.net/
Group: File tools
Packager: Victor Forsyuk <force@altlinux.ru>
Source0: http://download.sourceforge.net/clamav/clamav-%verstring.tar.gz
Source1: clamav.init
Source2: clamav.sysconfig

Source4: freshclam.cron
Source5: freshclam.logrotate
Source6: clamav.logrotate

Source10: clamav-milter.init
Source11: clamav-milter.sysconfig

Patch1: clamav-0.71-config.patch
Patch2: freshclam-0.71-config.patch

# Package with clamd should require libclamav, not vice versa.
# Corresponding libclamav version need to be updated before, or clamd restart may fail!
Requires: lib%{name} = %version-%release

# postinstall uses subst utility
Requires(post): sed >= 1:3.02-alt1

# Automatically added by buildreq on Tue Aug 03 2004
# ...and edited manually - buildreq put 'clamav' in BuildRequires :-[ ]]
BuildRequires: bzlib-devel libgmp-devel libwrap-devel zlib-devel

%{?_with_static:BuildRequires: glibc-devel-static}
%{?_with_milter:BuildRequires: sendmail-common sendmail-devel sendmail-libs}

%description
Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose
of this software is the integration with mail servers (attachment
scanning). The package provides a flexible and scalable
multi-threaded daemon, a commandline scanner, and a tool for
automatic updating via Internet. The programs are based on a
shared library distributed with the Clam AntiVirus package, which
you can use in your own software.

%package -n lib%{name}
Summary: Shared libraries for clamav
Group: Development/C

%description -n lib%{name}
Shared libraries for clamav.

%package -n lib%{name}-devel
Summary: Development header files and libraries for clamav
Group: Development/C
Requires: %name = %version

%description -n lib%{name}-devel
This package contains the development header files and libraries
necessary to develop clamav client applications.

%package -n lib%{name}-devel-static
Summary: clamav static libraries
Group: Development/C
Requires: lib%{name}-devel = %version

%description -n lib%{name}-devel-static
clamav static libraries.

%package milter
Summary: clamav-milter for sendmail
Group: File tools
Requires: clamav = %version, sendmail

%description milter
This package contains the filter for Sendmail necessary to
integrate clamav with Sendmail MTA.


%prep
%setup -q -n clamav-%verstring
%patch1 -p1
%patch2 -p1

%build
%ifdef snap
aclocal
%endif

# --disable-clamav: Disable test for clamav user/group
%configure \
	--disable-clamav \
	--with-user=mail \
	--with-group=mail \
	--with-dbdir=/var/lib/%name %{?_with_milter: --enable-milter}
%make_build

%install
make install DESTDIR=$RPM_BUILD_ROOT

%{!?_with_milter:rm -f $RPM_BUILD_ROOT/usr/share/man/man1/clamav-milter*}

install -d $RPM_BUILD_ROOT%{_sysconfdir}/{rc.d/init.d,sysconfig,cron.d,logrotate.d}
install -d $RPM_BUILD_ROOT%{_var}/log/clamav

install -m755 %_sourcedir/clamav.init $RPM_BUILD_ROOT/etc/rc.d/init.d/clamd
install -m755 %_sourcedir/clamav-milter.init $RPM_BUILD_ROOT/etc/rc.d/init.d/clamav-milter

install %_sourcedir/clamav.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/clamd
install %_sourcedir/clamav-milter.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/clamav-milter

touch $RPM_BUILD_ROOT%{_var}/log/clamav/clamd.log
touch $RPM_BUILD_ROOT%{_var}/log/clamav/freshclam.log

# install the logrotate stuff
install -m644 %_sourcedir/freshclam.logrotate $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/freshclam
install -m644 %_sourcedir/clamav.logrotate $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/clamav

# install config files _explicitly_
# they will not be installed by 'make install' if exists in build system :-\
install -m644 etc/clamav.conf $RPM_BUILD_ROOT%{_sysconfdir}/
install -m644 etc/freshclam.conf $RPM_BUILD_ROOT%{_sysconfdir}/

# pid file dir
install -d $RPM_BUILD_ROOT/var/run/clamav

# remove non-packaged files
%__rm -f %buildroot%_libdir/*.la
%__rm -f %buildroot/var/lib/clamav/*.cvd
%__rm -rf docs/html/CVS
%if_without static
%__rm -f %buildroot%_libdir/*.a
%endif

cat <<EOF >$RPM_BUILD_ROOT%{_sysconfdir}/cron.d/freshclam
30 */2 * * *       root    %_bindir/freshclam --quiet --daemon-notify
EOF

%post
# virus db format changed with 0.65, so delete old databases
%__rm -f /var/lib/clamav/viruses.db*

%post_service clamd

# randomize time of database updating (in order to distribute load on servers evenly)
RNDM=$[$RANDOM/546]
/usr/bin/subst s/^[0-9]*/$RNDM/ %_sysconfdir/cron.d/freshclam

%preun
%preun_service clamd

%post -n lib%{name} -p %post_ldconfig
%postun -n lib%{name} -p %postun_ldconfig

%post milter
%post_service clamav-milter

%preun milter
%preun_service clamav-milter

%files
# NEWS and README - identical files :-\
%doc AUTHORS BUGS ChangeLog FAQ README docs/html docs/clamdoc.*
%doc docs/signatures.*

%_bindir/clamdscan
%_bindir/clamscan
%_bindir/freshclam
%_bindir/sigtool
%_sbindir/clamd
%config(noreplace) %_initdir/clamd
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/*.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/clamav
%attr(640,root,root) %config(noreplace) %verify(not md5 size mtime) /etc/sysconfig/clamd
%_mandir/man1/clamdscan*
%_mandir/man1/clamscan*
%_mandir/man1/freshclam*
%_mandir/man1/sigtool*
%_mandir/man5/*
%_mandir/man8/clamd*
%attr(3775,root,mail) %dir /var/lib/clamav
%attr(3775,root,mail) %dir /var/run/clamav
%attr(3771,root,mail) %dir /var/log/clamav
%attr(640,mail,root) %ghost /var/log/clamav/clamd.log
%attr(644,mail,mail) %ghost /var/log/clamav/freshclam.log
%config(noreplace) %{_sysconfdir}/cron.d/freshclam
%config(noreplace) %{_sysconfdir}/logrotate.d/freshclam

%files -n lib%{name}
%_libdir/lib*.so.*

%files -n lib%{name}-devel
%_bindir/clamav-config
%_libdir/lib*.so
%_libdir/pkgconfig/*
%_includedir/*.h

%if_with static
%files -n lib%{name}-devel-static
%_libdir/lib*.a
%endif

%if_with milter
%files milter
%_sbindir/clamav-milter
%_initdir/clamav-milter
%config(noreplace) %verify(not md5 size mtime) /etc/sysconfig/clamav-milter
%_mandir/man8/clamav-milter.*
%endif

%changelog
* Mon Aug 02 2004 Victor Forsyuk <force@altlinux.ru> 0.75.1-alt1
- 0.75.1

* Fri Jun 25 2004 Victor Forsyuk <force@altlinux.ru> 0.73-alt1
- 0.73.
- Add pkgconfig file and clamav-config to -devel package.

* Wed May 19 2004 Victor Forsyuk <force@altlinux.ru> 0.71-alt1
- New version.

* Wed Apr 21 2004 Victor Forsyuk <force@altlinux.ru> 0.70-alt2
- New version.
- Freshclam launching time randomized at package installation.
  Thanks to Sergey Afonin <asy <at> kraft-s.ru> for idea.

* Wed Apr 14 2004 Victor Forsyuk <force@altlinux.ru> 0.70-alt1.20040414
- Build (post-0.70rc) snapshot from 2004/04/14.

* Mon Mar 01 2004 Victor Forsyuk <force@altlinux.ru> 0.67-alt2.20040301
- Build snapshot from 2004/03/01.
- Fix logrotate for clamd logs.
- Add --daemon-notify to options freshclam run with.
- Add build with milter and create clamav-milter subpackage.

* Sun Feb 15 2004 Victor Forsyuk <force@altlinux.ru> 0.67-alt1
- New version.
- Checks for new database every two hours (suggested by clamav authors).
- Rotate logs weekly (was monthly).

* Thu Dec 18 2003 Victor Forsyuk <force@altlinux.ru> 0.65-alt0.1
- New version.
- Removed *.la files.
- Do not build devel-static subpackage by default.

* Fri Jun 27 2003 Victor Forsyuk <force@altlinux.ru> 0.60-alt1
- Initial build for Sisyphus.
